﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Media.Imaging;

namespace ImageBindingDemo.ViewModels
{
    public class MainPageViewModel : INotifyPropertyChanged
    {
        const string IMAGE_URL = "http://chris.59north.com//file.axd?file=2010%2f10%2fchuckNorris2.jpg";

        public MainPageViewModel()
        {
            Image = new ImageViewModel(IMAGE_URL);

            BitmapImage img = new BitmapImage();
            img.SetSource(this.GetType().Assembly.GetManifestResourceStream("ImageBindingDemo.Images.chucken.jpg"));
            ImageWithFallback = new ImageViewModel("nonExistentUrl", img);
        }

        public string ImageUrl
        {
            get { return IMAGE_URL; }
        }
        public Uri ImageUri
        {
            get { return new Uri(IMAGE_URL); }
        }
        public ImageViewModel Image
        {
            get;
            private set;
        }
        public ImageViewModel ImageWithFallback
        {
            get;
            private set;
        }

        protected virtual void OnPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
